<?php

namespace Drupal\media_entity_remote_document\Plugin\Validation\Constraint;

use Symfony\Component\Validator\Constraint;

/**
 * Check if a value is a valid URL.
 *
 * @constraint(
 *   id = "RemoteDocumentUrl",
 *   label = @Translation("Remote document Url", context = "Validation"),
 *   type = { "link", "string", "string_long" }
 * )
 */
class RemoteDocumentUrlConstraint extends Constraint {

  /**
   * Valid file extensions.
   *
   * @var string[]
   */
  public array $allowedExtensions = [
    "pdf",
    "doc",
    "docx",
    "txt",
    "xls",
    "xlsx",
    "ppt",
    "pptx",
    "ods",
    "csv",
    "odt",
    "html",
  ];

  /**
   * The default violation message.
   *
   * @var string
   */
  public string $message = 'Not a valid document URL. Currently, valid file extensions include pdf, doc, docx, txt, xls, xlsx, ppt, pptx, ods, csv, odt, html';

}
